#define MASTER_CHALLENGE		5560020				// Master server heartbeat
#define	MASTER_PLAYERSTATS		47741				// Update a player's stats in the master

#define LAUNCHER_CHALLENGE		777123  // csdl challenge
//#define LAUNCHER_CHALLENGE		"\xA3\xDB\x0B\x00"  // csdl challenge in LSB order
//#define LAUNCHER_CHALLENGE_LSB	163		// Least significant byte of above number

#define	NUM_WAD_PATHS			5		// Number of wads launcher will report

#define	MAX_UDP_PACKET			1400		//Kilgore: was 8192

#define	SERVER_PORT				10666
#define	CLIENT_PORT				10667
#define	MASTER_PORT				15300

// Challengers
#define	CONNECT_CHALLENGE		200
#define	CONNECT_READY			201
#define	CONNECT_GETDATA			202
#define	CONNECT_QUIT			203

#define READ_BANLIST			204			// Internal message about re-reading the master ban list
#define REFRESH_BANLIST			205			// Msg. from master to refresh the global ban list

// Network messages (universal)
#define	NETWORK_ERROR			254

// Client network status
#define	ZD_DISCONNECTED		0
#define	ZD_CONNECTING		2
#define	ZD_CONNECTED		4
#define	ZD_PLAYING			8

// Number of maps allowed in map cycles
#define		ZD_MAX_MAPS		36

// Stuff
#define CM_X      1
#define CM_Y      2
#define CM_Z      4
#define CM_ANGLE  8
#define CM_MOMX   16
#define CM_MOMY   32
#define CM_MOMZ   64
#define CM_FRAME  128

// Identifying states (the cheap & easy way out)
#define	STATE_SPAWN				1
#define	STATE_SEE				2
#define	STATE_PAIN				3
#define	STATE_MELEE				4					
#define	STATE_MISSILE			5
#define	STATE_DEATH				6

// Identifying player states (again, cheap & easy)
#define	STATE_PLAYER_IDLE		7
#define	STATE_PLAYER_SEE		8
#define	STATE_PLAYER_ATTACK		9
#define	STATE_PLAYER_ATTACK2	10

// Flags for updating sectors
#define SUPDATE_CEILING			1	
#define SUPDATE_FLOOR			2
#define SUPDATE_FLOORTEXTURE	4
#define SUPDATE_CEILINGTEXTURE	8

// Client --> Server messages
#define		cl_userinfo				1
#define		cl_clientmove			2
#define		cl_weapslot				3
#define		cl_weapsel				4
#define		cl_pong					5
#define		cl_wantnewlevel			6
#define		cl_querything			7
#define		cl_chat					8
#define		cl_requestspawn			9
#define		cl_tryfire				10
#define		cl_missingplayer		11
#define		cl_useitem				12
#define		cl_requestrcon			13
#define		cl_rconcmd				14
#define		cl_teleport				15
#define		cl_ack					16
#define		cl_teamchat				17	//Kilgore
#define		cl_privchat				18	//Kilgore

// Server --> Client messages
#define		sv_consoleplayer		1
#define		sv_dmflags				2
#define		sv_skill				3
#define		sv_loadmap				4
#define		sv_spawnmobj			5
#define		sv_mobjangle			6
#define		sv_corpse				7
#define		sv_moveplayer			8
#define		sv_gametype				9
#define		sv_mobjstate			10
#define		sv_movething			11
#define		sv_spawnplayer			12
#define		sv_updatelocalplayer	13
#define		sv_spawnmissile			14
#define		sv_explodemissile		15
#define		sv_fireweapon			16
#define		sv_refireweapon			17
#define		sv_touchthing			18
#define		sv_ping					19
#define		sv_updateping			20
#define		sv_respawnitem			21
#define		sv_damagemobj			22
#define		sv_killmobj				23
#define		sv_damageplayer			24
#define		sv_killplayer			25
#define		sv_setspecificstate		26
#define		sv_toggleline			27
#define		sv_playernoway			28
#define		sv_dodoor				29
#define		sv_doplat				30
#define		sv_updatesector			31
#define		sv_destroymobj			32
#define		sv_secsound				33
#define		sv_secsoundid			34
#define		sv_stopsecseq			35
#define		sv_exitlevel			36
#define		sv_doreborn				37
#define		sv_newmap				38
#define		sv_moveplane			39
#define		sv_flattexture			40
#define		sv_dropitem				41
#define		sv_telemove				42
#define		sv_chat					43
#define		sv_spawnbot				44
#define		sv_playerstate			45
#define		sv_firepistol			46
#define		sv_fireshotgun			47
#define		sv_fireshotgun2			48
#define		sv_firechaingun			49
#define		sv_firerocket			50
#define		sv_fireplasma			51
#define		sv_firebfg				52
#define		sv_openshotgun2			53
#define		sv_loadshotgun2			54
#define		sv_closeshotgun2		55
#define		sv_userinfo				56
#define		sv_updatefrags			57
#define		sv_wepchange			58
#define		sv_rerespawn			59
#define		sv_newmap2				60		// does not disconnect
#define		sv_adminchat			61
#define		sv_disconnectclient		62
#define		sv_printf				63
#define		sv_firerailgun			64
#define		sv_disconnectbot		65
#define		sv_updateinv			66
#define		sv_useinv				67
#define		sv_givearti				68
#define		sv_spawnrain			69
#define		sv_motd					70
#define		sv_rconaccess			71
#define		sv_cantjoin				72
#define		sv_spreemsg				73
#define		sv_killmsg				74
#define		sv_playertimer			75
#define		sv_sawhit				76
#define		sv_missedpacket			77
#define		sv_kick					78
#define		sv_experience			79
#define		sv_header				80
#define		sv_teamchat				81	//Kilgore
#define		sv_updateteamscore		82	//Kilgore
#define		sv_special_event		83	//Kilgore
#define		sv_badteam				84	//Kilgore
#define		sv_privchat				85	//Kilgore
#define		sv_timeleft				86	//Kilgore
#if __CTF__
//duke
//==
#define		sv_ctf_event			87
#define		sv_ctf_state			88
//==                                  
#endif
